# Tamito KAJIYAMA <17 June 2001>
# Shyouzou Sugitani <08 February 2004>

import os
import re
import string
import sys
import urlparse
import whrandom
import types
import gc

if os.environ.has_key("DISPLAY"):
    import gtk

import ninix.seriko
import ninix.mayuna

import pix

class Menu:
    def __init__(self, ghost, surface, accelgroup):
        self.__ghost = ghost
        self.__surface = surface
        self.__menu_list = {
            'portal':    [_('Portal sites(_P)'), None, 1, 1, ('/portal', None, None, 0, '<Branch>')],
            'recommend': [_('Recommend sites(_R)'), None, 1, 1, ('/recommend', None, None, 0, '<Branch>')],
            'file':      [_('File(_F)'), None, 1, 1, ('/file', None, None, 0, '<Branch>')],
            'update':    [_('Network Update(_U)'), None, 1, 1, ('/file/update', None, self.__ghost.network_update, 0, '')],
            'vanish':    [_('Vanish(_F)'), None, 1, 1, ('/file/vanish', None, self.__ghost.vanish, 0, '')],
            'reload':    [_('Reload(_L)'), None, 1, 1, ('/file/reload', None, self.__ghost.reload, 0, '')],
            'settings':  [_('Settings...(_O)'), None, 1, 1, ('/file/settings', None, self.__ghost.edit_preferences, 0, '')],
            'usage':     [_('Usage graph(_A)'), None, 1, 1, ('/file/usage', None, self.__ghost.show_usage, 0, '')],
            'version':   [_('Version(_V)'), None, 1, 1, ('/file/version', None, self.__ghost.about, 0, '')],
            'exit':      [_('Exit(_Q)'), None, 1, 1, ('/file/exit', None, self.__ghost.close, 0, '')],
            'ghost':     [_('Ghost(_G)'), None, 1, 1, ('/ghost', None, None, 0, '<Branch>')],
            'shell':     [_('Shell(_S)'), None, 1, 1, ('/shell', None, None, 0, '<Branch>')],
            'balloon':   [_('Balloon(_B)'), None, 1, 1, ('/balloon', None, None, 0, '<Branch>')],
            'scaling':   [_('Surface Scaling(_S)'), None, 1, 1, ('/scaling', None, None, 0, '<Branch>')],
            'costume':   [_('Costume(_C)'), None, 1, 1, ('/costume', None, None, 0, '<Branch>')],
            'stick':     [_('Stick(_Y)'), None, 1, 1, ('/stick', None, self.__surface.window_stick, 0, '<CheckItem>')],
            'wait':      [_('Script Wait(_W)'), None, 1, 1, ('/wait', None, None, 0, '<Branch>')],
            'kinoko':    [_('Nekodorifu(_N)'), None, 1, 1, ('/neko', None, None, 0, '<Branch>')],
            'neko':      [_('Kinoko(_K)'), None, 1, 1, ('/kinoko', None, None, 0, '<Branch>')],
            'plugin':    [_('Plugin(_P)'), None, 1, 1, ('/plugin', None, None, 0, '<Branch>')]
            }
        self.__pixmap = None
        self.__fontcolor = "#000000"
        menu_items = (
            self.__menu_list['portal'][-1],
            self.__menu_list['recommend'][-1],
            ('/Separator', None, None, 0, '<Separator>'),
            self.__menu_list['file'][-1],
            self.__menu_list['update'][-1],
            self.__menu_list['vanish'][-1],
            self.__menu_list['reload'][-1],
            self.__menu_list['settings'][-1],
            self.__menu_list['usage'][-1],
            self.__menu_list['version'][-1],
            self.__menu_list['exit'][-1],
            self.__menu_list['ghost'][-1],
            self.__menu_list['shell'][-1],
            self.__menu_list['balloon'][-1],
            self.__menu_list['scaling'][-1],
            self.__menu_list['costume'][-1],
            self.__menu_list['stick'][-1],
            self.__menu_list['wait'][-1],
            ('/Separator', None, None, 0, '<Separator>'),
            self.__menu_list['neko'][-1],
            self.__menu_list['kinoko'][-1],
            self.__menu_list['plugin'][-1],
            )
        self.__item_factory = gtk.ItemFactory(gtk.Menu, '<main>', accelgroup)
        self.__item_factory.create_items(menu_items)
        self.__popup_menu = self.__item_factory.get_widget('<main>')
        for key in self.__menu_list.keys():
            path = self.__menu_list[key][-1][0]
            self.__menu_list[key][1] = self.__item_factory.get_item(path)
    def set_fontcolor(self, r, g ,b):
        self.__fontcolor = "#%02x%02x%02x" % (r, g, b)
    def set_pixmap(self, path_background, path_sidebar):
        if path_background and os.path.exists(path_background):
            pixbuf = pix.create_pixbuf_from_file(path_background, 'png')
        else:
            self.__pixmap = None
            return
        if path_sidebar and os.path.exists(path_sidebar):
            pixbuf_sidebar = pix.create_pixbuf_from_file(path_sidebar, 'png')
        else:
            pixbuf_sidebar = None
        if pixbuf_sidebar:
            width = pixbuf.get_width()
            height = pixbuf.get_height()
            sidebar_width = pixbuf_sidebar.get_width()
            sidebar_height = pixbuf_sidebar.get_height()
            new_pixbuf = gtk.gdk.Pixbuf(
                pixbuf.get_colorspace(), gtk.FALSE,
                pixbuf.get_bits_per_sample(),
                width + sidebar_width, max(height, sidebar_height))
            pixbuf.composite(
                new_pixbuf,
                0, 0, new_pixbuf.get_width(), new_pixbuf.get_height(),
                width - 1, height - 1,
                1.0, 1.0, gtk.gdk.INTERP_BILINEAR, 255)
            pixbuf_sidebar.composite(
                new_pixbuf,
                0, 0, sidebar_width, sidebar_height,
                0, 0,
                1.0, 1.0, gtk.gdk.INTERP_BILINEAR, 255)
            pixbuf.composite(
                new_pixbuf,
                sidebar_width, 0, width, height,
                0, 0,
                1.0, 1.0, gtk.gdk.INTERP_BILINEAR, 255)
            pixbuf = new_pixbuf
        pixmap, mask = pixbuf.render_pixmap_and_mask(255)
        self.__pixmap = pixmap
    def __set_mayuna_menu(self, side):
        if self.__mayuna_menu[side] != None:
            self.__menu_list['costume'][1].set_submenu(self.__mayuna_menu[side])
            self.__menu_list['costume'][1].show()
        else:
            self.__menu_list['costume'][1].hide()
    def create_mayuna_menu(self, mayuna_menu):
        self.__mayuna_menu = []
        for side, index in [('sakura', 0), ('kero', 1)]:
            if mayuna_menu[side]:
                self.__mayuna_menu.append(gtk.Menu())
                item = gtk.TearoffMenuItem()
                item.show()
                if self.__pixmap:
                    item.window.set_back_pixmap(self.__pixmap, gtk.FALSE)
                self.__mayuna_menu[index].append(item)
                for j in range(len(mayuna_menu[side])):
                    key, name, state = mayuna_menu[side][j]
                    if key != '-':
                        item = gtk.CheckMenuItem(name)
                        item.set_name("popup menu item")
                        if state:
                            item.set_active(gtk.TRUE)
                        else:
                            item.set_active(gtk.FALSE)
                        item.connect("activate", self.__surface.toggle_bind, (index, key))
                    else:
                        item = gtk.SeparatorMenuItem()
                    item.show()
                    self.__mayuna_menu[index].append(item)
            else:
                self.__mayuna_menu.append(None)
    __re_shortcut = re.compile(r'&(?=[\x21-\x7e])')
    def __modify_shortcut(self, caption):
        return self.__re_shortcut.sub('_', caption)
    __re_accel = re.compile(r'\(_.\)|_')
    def __cut_accel(self, caption):
        return self.__re_accel.sub('', caption)
    __ui = {'update': ([["updatebuttoncaption", "updatebutton.caption"], ["updatebuttoncaption", "updatebutton.caption"]], "(_U)", [[],[]]),
            'vanish': ([["vanishbuttoncaption", "vanishbutton.caption"], ["vanishbuttoncaption", "vanishbutton.caption"]], "(_F)", [["vanishbuttonvisible", "vanishbutton.visible"], ["vanishbuttonvisible", "vanishbutton.visible"]]),
            'portal': ([["sakura.portalbuttoncaption", "portalrootbutton.caption"], []], "(_P)", [[], None]),
            'recommend': ([["sakura.recommendbuttoncaption", "recommendrootbutton.caption"], ["kero.recommendbuttoncaption"]], "(_R)", [[], []]),
           }
    def __update_ui(self, side):
        for key in self.__ui.keys():
            if not self.__menu_list.has_key(key):
                continue
            list = self.__ui[key][0][side]
            if list: # caption
                for name in list:
                    caption = self.__ghost.getstring(name)
                    if caption:
                        break
                if caption:
                    caption = self.__modify_shortcut(caption)
                    if caption == self.__cut_accel(caption):
                        caption = caption + self.__ui[key][1]
                    self.__set_caption(key, caption)
            list = self.__ui[key][2][side]
            if list: # visible
                for name in list:
                    visible = self.__ghost.getstring(name)
                    if visible is not None:
                        break
                if visible == "0":
                    self.__set_visible(key, 0)
                else:
                    self.__set_visible(key, 1)
            elif visible is None:
                self.__set_visible(key, 0)
    def popup(self, button, side): ## FIXME
        self.__update_ui(side)
        if side == 0:
            portal = self.__ghost.getstring("sakura.portalsites")
        else:
            portal = None
        self.__set_portal_menu(side, portal)
        recommend = self.__ghost.getstring(["sakura.recommendsites", "kero.recommendsites"][side])
        self.__set_recommend_menu(side, recommend)
        self.__set_ghost_menu()
        self.__set_shell_menu()
        self.__set_balloon_menu()
        self.__set_plugin_menu()
        self.__set_scale_menu()
        self.__set_speed_menu()
        self.__set_mayuna_menu(side)
        for key in self.__menu_list.keys():
            text = self.__menu_list[key][0]
            item = self.__menu_list[key][1]
            visible = self.__menu_list[key][2]
            changed = self.__menu_list[key][3]
            if item and changed:
                self.__menu_list[key][3] = 0 # changed
                if visible:
                    label = item.get_children()[0]
                    markup = '<span foreground="%s">   ' % self.__fontcolor + text + '</span>'
                    label.set_markup_with_mnemonic(markup)
                    item.show()
                    if self.__pixmap: ## FIXME
                        if key in ['file', 'update']:
                            item = self.__menu_list[key][1]
                            item.realize()
                            item.window.set_back_pixmap(self.__pixmap, gtk.FALSE)
                        #if key in ['portal', 'recommend', 'ghost', 'shell', 'balloon', 'costume', 'scaling', 'wait', 'neko', 'kinoko', 'plugin']:
                        #    item_list = self.__menu_list[key][1].get_submenu().get_children()
                        #    if len(item_list) > 0:
                        #        item = item_list[0]
                        #        item.realize()
                        #        item.window.set_back_pixmap(self.__pixmap, gtk.FALSE)
                else:
                    item.hide()
        self.__popup_menu.popup(None, None, None, button, 0)
    def __set_caption(self, name, caption):
        assert self.__menu_list.has_key(name)
        assert type(caption) in [types.StringType, types.UnicodeType]
        if self.__menu_list[name][2] == caption:
            return
        self.__menu_list[name][0] = caption
        self.__menu_list[name][3] = 1 # changed
    def __set_visible(self, name, visible):
        assert self.__menu_list.has_key(name)
        assert visible in [0, 1]
        if self.__menu_list[name][2] == visible:
            return
        self.__menu_list[name][2] = visible
        self.__menu_list[name][3] = 1 # changed
    def __set_portal_menu(self, side, portal):
        if side == 1:
            self.__set_visible('portal', 0)
        else:
            if portal:
                menu = gtk.Menu()
                list = string.split(portal, chr(2))
                for site in list:
                    entry = string.split(site, chr(1))
                    if len(entry) < 1:
                        continue
                    title = entry[0]
                    if title == '-':
                        item = gtk.SeparatorMenuItem()
                    else:
                        if len(entry) < 2:
                            continue
                        url = entry[1]
                        if len(entry) > 2:
                            bannar = entry[2] ## FIXME
                        else:
                            bannar = None
                        item = gtk.MenuItem(title)
                        item.connect("activate", self.__ghost.launch_browser, (title, url))
                    menu.add(item)
                    item.show()
                self.__menu_list['portal'][1].set_submenu(menu)
                menu.show()
                self.__set_visible('portal', 1)
            else:
                self.__set_visible('portal', 0)
    def __set_recommend_menu(self, side, recommend):
        if recommend:
            menu = gtk.Menu()
            list = string.split(recommend, chr(2))
            for site in list:
                entry = string.split(site, chr(1))
                if len(entry) < 1:
                    continue
                title = entry[0]
                if title == '-':
                    item = gtk.SeparatorMenuItem()
                else:
                    if len(entry) < 2:
                        continue
                    url = entry[1]
                    if len(entry) > 2:
                        bannar = entry[2] ## FIXME
                    else:
                        bannar = None
                    item = gtk.MenuItem(title)
                    item.connect("activate", self.__ghost.launch_browser, (title, url))
                menu.add(item)
                item.show()
            self.__menu_list['recommend'][1].set_submenu(menu)
            menu.show()
            self.__set_visible('recommend', 1)
        else:
            self.__set_visible('recommend', 0)
    def __set_ghost_menu(self): ## FIXME
        self.__ghost.app.set_ghost_menu(self.__menu_list['ghost'][1])
        self.__menu_list['ghost'][3] = 1
    def __set_shell_menu(self): ## FIXME
        self.__ghost.app.set_shell_menu(self.__menu_list['shell'][1])
        self.__menu_list['shell'][3] = 1
    def __set_balloon_menu(self): ## FIXME
        self.__ghost.app.set_balloon_menu(self.__menu_list['balloon'][1])
        self.__menu_list['balloon'][3] = 1
    def __set_plugin_menu(self): ## FIXME
        self.__ghost.app.set_plugin_menu(self.__menu_list['plugin'][1])
        self.__menu_list['plugin'][3] = 1
    def __set_scale_menu(self): ## FIXME
        self.__ghost.app.set_scale_menu(self.__menu_list['scaling'][1])
        self.__menu_list['scaling'][3] = 1
    def __set_speed_menu(self): ## FIXME
        self.__ghost.app.set_speed_menu(self.__menu_list['wait'][1])
        self.__menu_list['wait'][3] = 1
    def get_stick(self):
        item = self.__menu_list['stick'][1]
        if item and item.get_active():
            return 1
        else:
            return 0

class Surface:
    def __init__(self, sakura, debug=0):
        self.sakura = sakura
        self.debug = debug
        self.gtk_window = []
        self.accelgroup = gtk.AccelGroup()
        for name in ["sakura", "unyuu"]:
            window = gtk.Window()
            window.set_title('surface.' + name)
            window.set_decorated(gtk.FALSE)
            window.set_resizable(gtk.FALSE)
            window.connect("delete_event", self.delete)
            window.connect("key_press_event", self.key_press)
            window.connect("window_state_event", self.window_state)
            window.set_events(gtk.gdk.KEY_PRESS_MASK)
            window.realize()
            window.add_accel_group(self.accelgroup)
            self.gtk_window.append(window)
        self.window = []
    def window_state(self, window, event):
        if event.new_window_state == 2:
            if window == self.gtk_window[0]:
                self.sakura.cantalk = 0
                if not self.sakura.passivemode:
                    self.sakura.reset_script(1)
                    self.sakura.stand_by(1)
                    self.sakura.notify_event("OnWindowStateMinimize")
            for gtk_window in self.gtk_window:
                if gtk_window != window and gtk_window.window.get_state() != 2:
                    gtk_window.iconify()
        else:
            for gtk_window in self.gtk_window:
                if gtk_window != window and gtk_window.window.get_state() == 2:
                    gtk_window.deiconify()
            if window == self.gtk_window[0] and self.sakura.cantalk == 0:
                self.sakura.cantalk = 1
                if not self.sakura.passivemode:
                    self.sakura.notify_event("OnWindowStateRestore")
        return gtk.TRUE
    def delete(self, window, event):
        self.sakura.finalize()
        gtk.mainquit()
        return gtk.FALSE
    def key_press(self, window, event):
        self.sakura.notify_key_press(event.keyval, event.string)
        return gtk.TRUE
    def window_stick(self, action, widget):
        stick = self.__menu.get_stick()
        for window in self.gtk_window:
            if stick:
                window.stick()
            else:
                window.unstick()
    def open_popup_menu(self, button, side):
        self.__menu.popup(button, side)
    re_surface_id = re.compile("^surface([0-9]+)$")
    def new(self, desc, alias, surface, name, prefix):
        self.desc = desc
        self.name = name
        self.prefix = prefix
        if alias is None:
            alias0 = alias1 = None
        else:
            alias0 = alias.get("sakura.surface.alias")
            alias1 = alias.get("kero.surface.alias")
        # load pixmap
        pixbufs = {}
        elements = {}
        for basename in surface.keys():
            path, config = surface[basename]
            if path is None:
                continue
            if not os.path.exists(path):
                name, suffix = os.path.splitext(path)
                dgp_path = name + '.dgp'
                if not os.path.exists(dgp_path):
                    print "%s: file not found (ignored)" % path
                    continue
                else:
                    path = dgp_path
            elements[basename] = [[path], None, None]
            match = self.re_surface_id.match(basename)
            if not match:
                continue
            key = match.group(1)
            pixbufs[key] = elements[basename]
        # compose surface elements
        composite_pixbuf = {}
        for basename in surface.keys():
            match = self.re_surface_id.match(basename)
            if not match:
                continue
            key = match.group(1)
            path, config = surface[basename]
            if config.has_key("element0"):
                if self.debug & 8192:
                    print "surface", key
                composite_pixbuf[key] = self.compose_elements(elements, config)
        pixbufs.update(composite_pixbuf)
        # check if necessary surfaces have been loaded
        for key in ["0", "10"]:
            if not pixbufs.has_key(key):
                sys.stderr.write("cannot load surface #%s (abort)\n" % key)
                sys.exit(1)
        # arrange surface configurations
        seriko = {}
        region = {}
        for basename in surface.keys():
            match = self.re_surface_id.match(basename)
            if not match:
                continue
            key = match.group(1)
            path, config = surface[basename]
            # define animation patterns
            seriko[key] = ninix.seriko.get_actors(config)
            # define collision areas
            buffer = []
            for n in range(256):
                rect = config.get("collision" + str(n)) # "redo" syntax
                if rect is None:
                    continue
                values = string.split(rect, ",")
                if len(values) != 5:
                    continue
                try:
                    x1, y1, x2, y2 = map(string.atoi, values[:4])
                except ValueError:
                    continue
                buffer.append((string.strip(values[4]), x1, y1, x2, y2))
            for part in ["head", "face", "bust"]:
                rect = config.get("collision." + part) # "inverse" syntax
                if not rect:
                    continue
                try:
                    x1, y1, x2, y2 = map(string.atoi, string.split(rect, ","))
                except ValueError:
                    pass
                buffer.append((string.capitalize(part), x1, y1, x2, y2))
            region[key] = buffer
        # MAYUNA
        mayuna = {}
        for basename in surface.keys():
            match = self.re_surface_id.match(basename)
            if not match:
                continue
            key = match.group(1)
            path, config = surface[basename]
            # define animation patterns
            mayuna[key] = ninix.mayuna.get_mayuna(config)
        bind = {}
        for side in ["sakura", "kero"]:
            bind[side] = {}
            for index in range(128):
                name = self.desc.get('%s.bindgroup%d.name' % (side, index), None)
                default = self.desc.get('%s.bindgroup%d.default' % (side, index), 0)
                if name != None:
                    bind[side][index] = [name, default]
        self.mayuna = {}
        for side in ["sakura", "kero"]:
            self.mayuna[side] = []
            for index in range(128):
                key = self.desc.get('%s.menuitem%d' % (side, index), None)
                if key == '-':
                    self.mayuna[side].append([key, None, 0])
                else:
                    try:
                        key = int(key)
                    except:
                        pass
                    else:
                        if bind[side].has_key(key):
                            name = string.split(bind[side][key][0], ',')
                            self.mayuna[side].append([key, name[1], bind[side][key][1]])
        # create surface windows
        for surface_window in self.window:
            surface_window.destroy()
        self.window = []
        self.window.append(SurfaceWindow(
            self.gtk_window[0], 0,
            self.sakura, desc, alias0, surface, pixbufs, seriko, region, mayuna, bind["sakura"],
            "0",self.debug))
        self.window.append(SurfaceWindow(
            self.gtk_window[1], 1,
            self.sakura, desc, alias1, surface, pixbufs, seriko, region, mayuna, bind["kero"],
            "10", self.debug))
        for name, window in [("sakura", self.gtk_window[0]),
                             ("unyuu", self.gtk_window[1])]:
            if name == "sakura":
                title = self.sakura.get_selfname() or 'surface.' + name
            else:
                title = self.sakura.get_keroname() or 'surface.' + name
            window.set_title(title)
        self.__menu = Menu(self.sakura.ghost, self, self.accelgroup)
        dir = self.prefix
        name = self.desc.get("menu.background.bitmap.filename", "menu_background.png")
        name = string.replace(name, '\\', '/')
        path = os.path.join(dir, name)
        if not os.path.exists(path):
            dir = os.path.join(self.sakura.ghost.get_prefix(), "ghost", "master")
            path = os.path.join(dir, "menu_background.png")
            if os.path.exists(path):
                path_background = path
            else:
                path_background = None
            path = os.path.join(dir, "menu_sidebar.png")
            if os.path.exists(path):
                path_sidebar = path
            else:
                path_sidebar = None
        else:
            path_background = path
            name = self.desc.get("menu.sidebar.bitmap.filename", "menu_sidebar.png")
            name = string.replace(name, '\\', '/')
            path = os.path.join(dir, name)
            if os.path.exists(path):
                path_sidebar = path
            else:
                path_sidebar = None
        if path_background:
            self.__menu.set_pixmap(path_background, path_sidebar)
        fontcolor_r = self.desc.getint('menu.background.font.color.r', 0)
        fontcolor_g = self.desc.getint('menu.background.font.color.g', 0)
        fontcolor_b = self.desc.getint('menu.background.font.color.b', 0)
        self.__menu.set_fontcolor(fontcolor_r, fontcolor_g, fontcolor_b)
        self.__menu.create_mayuna_menu(self.get_mayuna_menu())
    def get_mayuna_menu(self):
        for side, index in [('sakura', 0), ('kero', 1)]:
            for menu in self.mayuna[side]:
                if menu[0] != '-':
                    menu[2] = self.window[index].bind[menu[0]][1]
        return self.mayuna
    def compose_elements(self, elements, config):
        error = None
        for n in range(256):
            key = "element" + str(n)
            if not config.has_key(key):
                break
            spec = map(string.strip, string.split(config[key], ","))
            try:
                method, filename, x, y = spec
                x = int(x)
                y = int(y)
            except ValueError:
                error = "invalid element spec for %s: %s" % (key, config[key])
                break
            basename, suffix = os.path.splitext(filename)
            if string.lower(suffix) != ".png":
                error = "unsupported file format for %s: %s" % (key, filename)
                break
            basename = string.lower(basename)
            if not elements.has_key(basename):
                error = "%s file not found: %s" % (key, filename)
                break
            pixbuf = elements[basename][0][0]
            if n == 0: # base surface
                pixbuf_list = [pixbuf]
            elif method == "overlay":
                pixbuf_list.append((pixbuf, x, y))
            else:
                error = "unknown method for %s: %s" % (key, method)
                break
            if self.debug & 8192:
                print "%s: %s %s, x=%d, y=%d, w=%d, h=%d" % (
                    key, method, filename, x, y, w, h)
        if error is not None:
            print error
            pixbuf_list = []
        return [pixbuf_list, None, None]
    def reset_surface(self, side):
        self.window[side].reset_surface()
    def set_surface(self, side, id):
        self.window[side].set_surface(id)
    def get_surface(self, side):
        return self.window[side].get_surface()
    def get_surface_size(self, side):
        return self.window[side].get_surface_size()
    def get_surface_offset(self, side):
        return self.window[side].get_surface_offset()
    def get_touched_region(self, side, x, y):
        return self.window[side].get_touched_region(x, y)
    def set_direction(self, side, dir):
        self.window[side].set_direction(dir)
    def set_position(self, side, x, y):
        self.window[side].set_position(x, y)
    def get_position(self, side):
        return self.window[side].get_position()
    def set_alignment(self, side, align):
        self.window[side].set_alignment(align)
    def get_alignment(self, side):
        return self.window[side].get_alignment()
    def reset_alignment(self):
        if self.desc.get('seriko.alignmenttodesktop') == 'free':
            align = 2
        else:
            align = 0
        self.set_alignment(0, align)
        self.set_alignment(1, align)
    def show(self, side):
        self.window[side].show()
    def hide(self, side):
        self.window[side].hide()
    def raise_(self, side):
        self.window[side].raise_()
    def lower(self, side):
        self.window[side].lower()
    def invoke(self, side, id):
        self.window[side].invoke(id)
    def update(self):
        for surface_window in self.window:
            surface_window.update()
    def set_icon(self, path):
        if path != None:
            pixbuf = pix.create_pixbuf_from_file(path, 'ico')
        else:
            pixbuf = None
        for window in self.gtk_window:
            try: # bug in pygtk (<= 1.99.16)
                window.set_icon(pixbuf)
            except:
                pass
    def get_name(self):
        return self.name
    def get_username(self):
        return self.desc.get("user.defaultname")
    def get_selfname(self):
        return self.desc.get("sakura.name")
    def get_selfname2(self):
        return self.desc.get("sakura.name2")
    def get_keroname(self):
        return self.desc.get("kero.name")
    def get_friendname(self):
        return self.desc.get("sakura.friend.name")
    def get_balloon_offset(self, side):
        if side == 0:
            x, y = self.window[side].get_balloon_offset()
            if x == None:
                x = self.desc.getint("sakura.balloon.offsetx", 0)
            if y == None:
                y = self.desc.getint("sakura.balloon.offsety", 0)
        else:
            x, y = self.window[side].get_balloon_offset()
            if x == None:
                x = self.desc.getint("kero.balloon.offsetx", 0)
            if y == None:
                y = self.desc.getint("kero.balloon.offsety", 0)
        if self.sakura.surface_scale != 100:
            x = x * self.sakura.surface_scale / 100
            y = y * self.sakura.surface_scale / 100
        return x, y
    def window_get_pointer(self):
        self.window[0].get_pointer()
        self.window[1].get_pointer()
    def toggle_bind(self, event, args):
        side, id = args
        self.window[side].toggle_bind(id)

class SurfaceWindow:
    # DnD data types
    dnd_targets = [
        ("text/plain", 0, 0),
        ]
    def __init__(self, window, side, sakura, desc, alias, surface,
                 pixbuf, seriko, region, mayuna, bind, default_id, debug):
        self.window = window
        self.side = side
        self.sakura = sakura
        self.desc = desc
        self.alias = alias
        self.align = 0
        if self.alias is not None:
            default_id = self.alias.get(default_id, [default_id])[0]
        self.surface = surface
        self.surface_id = default_id
        self.base_id = default_id
        self.exclusive_actor = None
        self.pixbuf = pixbuf
        self.seriko = seriko
        self.region = region
        self.mayuna = mayuna
        self.bind = bind
        self.surface_cache = {}
        self.default_id = default_id
        self.debug = debug
        self.shown = 0
        self.dragged = 0
        self.set_position(0, 0)
        self.set_direction(side)
        self.x_root = None
        self.y_root = None
        self.reset_overlays()
        # create drawing area
        self.darea = gtk.DrawingArea()
        self.darea.show()
        self.darea.set_events(gtk.gdk.EXPOSURE_MASK|
                              gtk.gdk.BUTTON_PRESS_MASK|
                              gtk.gdk.BUTTON_RELEASE_MASK|
                              gtk.gdk.POINTER_MOTION_MASK|
                              gtk.gdk.POINTER_MOTION_HINT_MASK|
                              gtk.gdk.SCROLL_MASK)
        self.callbacks = []
        for signal, func in [("button_press_event",   self.button_press),
                             ("button_release_event", self.button_release),
                             ("motion_notify_event",  self.motion_notify),
                             ("drag_data_received",   self.drag_data_received),
                             ("scroll_event",         self.scroll),
                             ]:
            self.callbacks.append(self.darea.connect(signal, func))
        self.darea.drag_dest_set(gtk.DEST_DEFAULT_ALL, self.dnd_targets,
                                 gtk.gdk.ACTION_COPY)
        self.window.add(self.darea)
        self.darea.realize()
        self.set_surface(None)
    def drag_data_received(self, widget, context, x, y, data, info, time):
        if self.debug & 8192:
            print "Content-type:", data.type
            print "Content-length:", data.length
            print repr(data.data)
        if str(data.type) == "text/plain":
            list = []
            for line in string.split(data.data, "\r\n"):
                scheme, host, path, params, query, fragment = \
                        urlparse.urlparse(line)
                if scheme == "file" and os.path.exists(path):
                    list.append(path)
            if list:
                self.sakura.notify_file_drop(list, self.side)
        return gtk.TRUE
    def invoke(self, id):
        for actor in self.seriko[self.base_id]:
            if id == actor.get_id():
                actor.invoke()
                if actor.exclusive:
                    self.exclusive_actor = actor
                    break
    def update(self):
        if self.exclusive_actor:
            self.reset_overlays()
            self.exclusive_actor.update(self)
            self.draw_overlays()
            if self.exclusive_actor == None or \
               self.exclusive_actor.wait == -1:
                self.exclusive_actor = None
        else:
            last_overlays = self.overlays.copy()
            for actor in self.seriko[self.base_id]:
                if actor.exclusive and actor.wait == 1:
                    self.reset_overlays()
                    actor.update(self)
                    self.draw_overlays()
                    if self.exclusive_actor != None and \
                       self.exclusive_actor.wait != -1:
                        self.exclusive_actor = actor
                    else:
                        self.exclusive_actor = None
                    return
                else:
                    actor.update(self)
            if self.overlays != last_overlays:
                self.draw_overlays()
    def terminate(self):
        for actor in self.seriko[self.base_id]:
            actor.terminate()
        self.reset_overlays()
    def reset_surface(self):
        id = self.get_surface()
        self.set_surface(id, force=1)
    def set_surface(self, id, reset=1, force=0):
        if self.alias is not None and self.alias.has_key(id):
            aliases = self.alias.get(id)
            if len(aliases) > 0:
                id = whrandom.choice(aliases)
        if not force and self.surface_id == id and self.shown:
            return
        if id == "-2" or reset:
            self.terminate()
        if id in ["-1", "-2"]:
            pass
        elif not self.pixbuf.has_key(id):
            self.surface_id = self.default_id
        else:
            self.surface_id = id
        if reset:
            if self.seriko.has_key(id):
                self.base_id = id
            else:
                self.base_id = self.surface_id
            self.exclusive_actor = None
            for actor in self.seriko[self.base_id]:
                if actor.get_interval() == "runonce":
                    actor.invoke()
                    if actor.exclusive:
                        self.exclusive_actor = actor
                        break
        # define collision areas
        self.collisions = self.region[self.surface_id]
        self.draw_surface()
        self.show_surface()
        # resize window
        w, h = self.get_surface_size(self.surface_id)
        self.darea.set_size_request(w, h)
        # relocate window
        x, y = self.get_position()
        dw, dh = self.get_surface_size(self.default_id) # default surface size
        xoffset = (dw - w)/2
        if self.get_alignment() == 0:
            yoffset = dh - h
            scrn_h = gtk.gdk.screen_height() - self.sakura.bottom_margin
            y = scrn_h - dh
        elif self.get_alignment() == 1:
            yoffset = 0
        else:
            yoffset = (dh - h)/2
        self.window_offset = (xoffset, yoffset)
        self.set_position(x, y)
    def compose_surface(self, surface_pixbuf, mayuna, done):
        for pattern in mayuna.patterns:
            surface, method, args = pattern
            if method in ['bind', 'add']:
                if self.pixbuf.has_key(surface):
                    x, y = args
                    pixbuf = self.get_pixbuf(surface)
                    w = pixbuf.get_width()
                    h = pixbuf.get_height()
                    # overlay surface pixbuf
                    sw = surface_pixbuf.get_width()
                    sh = surface_pixbuf.get_height()
                    if x + w > sw:
                        w = sw - x
                    if y + h > sh:
                        h = sh - y
                    if x < 0:
                        dest_x = 0
                        w = w + x
                    else:
                        dest_x = x
                    if y < 0:
                        dest_y = 0
                        h = h + y
                    else:
                        dest_y = y
                    pixbuf.composite(surface_pixbuf, dest_x, dest_y, w, h, x, y, 1.0, 1.0, gtk.gdk.INTERP_BILINEAR, 255)
                ##if method == 'bind':
                ##    break
            elif method == 'reduce':
                if self.pixbuf.has_key(surface):
                    x, y = args
                    pixbuf = self.get_pixbuf(surface)
                    w = pixbuf.get_width()
                    h = pixbuf.get_height()
                    surface_pixbuf = pix.reduce_pixbuf(surface_pixbuf, pixbuf, x, y)
            elif method == 'insert':
                index = args[0]
                for actor in self.mayuna[self.surface_id]:
                    id = actor.get_id()
                    if id == index:
                        if self.bind.has_key(id) and self.bind[id][1] and \
                           id not in done:
                            done.append(id)
                            sueface_pixbuf = self.compose_surface(surface_pixbuf, actor, done)
                        else:
                            break
            else:
                raise RuntimeError, "should not reach here"
        return surface_pixbuf
    def get_pixbuf(self, id):
        if not self.pixbuf.has_key(id):
            pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, gtk.TRUE, 8, 8, 8)
            pixbuf.fill(0xffffffff)
            return pixbuf
        if self.pixbuf[id][1] != None:
            pixbuf = self.pixbuf[id][1]
        else:
            if len(self.pixbuf[id][0]) == 0:
                pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, gtk.TRUE, 8, 8, 8)
                pixbuf.fill(0xffffffff)
            else:
                pixbuf = pix.create_pixbuf_from_file(self.pixbuf[id][0][0])
                for element, x, y in self.pixbuf[id][0][1:]:
                    overlay = pix.create_pixbuf_from_file(element)
                    w = overlay.get_width()
                    h = overlay.get_height()
                    sw = pixbuf.get_width()
                    sh = pixbuf.get_height()
                    if x + w > sw:
                        w = sw - x
                    if y + h > sh:
                        h = sh - y
                    if x < 0:
                        dest_x = 0
                        w = w + x
                    else:
                        dest_x = x
                    if y < 0:
                        dest_y = 0
                        h = h + y
                    else:
                        dest_y = y
                    overlay.composite(pixbuf, dest_x, dest_y, w, h, x, y, 1.0, 1.0, gtk.gdk.INTERP_BILINEAR, 255)
            self.pixbuf[id][1] = pixbuf
            deleted = 0
            for key in self.pixbuf.keys():
                if key not in [id, '0', '10'] and self.pixbuf[key][2] != None:
                    self.pixbuf[key][2] = self.pixbuf[key][2] - 1
                    if self.pixbuf[key][2] < 0:
                        self.pixbuf[key][1] = None
                        self.pixbuf[id][2] = None 
                        deleted = 1
            if deleted:
                gc.collect() ## FIXME
            self.pixbuf[id][2] = 15
        return pixbuf
    def draw_surface(self):
        pixbuf = self.get_pixbuf(self.surface_id)
        w = pixbuf.get_width()
        h = pixbuf.get_height()
        if self.surface_cache.has_key(self.surface_id):
            surface_pixbuf =  self.surface_cache[self.surface_id].copy()
        else:
            surface_pixbuf = pixbuf.copy()
            if self.mayuna.has_key(self.surface_id):
                done = []
                for actor in self.mayuna[self.surface_id]:
                    id = actor.get_id()
                    if self.bind.has_key(id) and self.bind[id][1] and \
                       id not in done:
                        done.append(id)
                        sueface_pixbuf = self.compose_surface(surface_pixbuf, actor, done)
                self.surface_cache[self.surface_id] = surface_pixbuf
        if self.sakura.surface_scale != 100:
            w = w * self.sakura.surface_scale / 100
            h = h * self.sakura.surface_scale / 100
            surface_pixbuf = surface_pixbuf.scale_simple(w, h, gtk.gdk.INTERP_BILINEAR)
        self.surface_pixmap, self.mask_pixmap = surface_pixbuf.render_pixmap_and_mask(255)
        if self.debug & 4096:
            self.draw_region()
    def draw_region(self):
        surface_gc = self.surface_pixmap.new_gc()
        surface_gc.function = gtk.gdk.INVERT
        for part, x1, y1, x2, y2 in self.collisions:
            if self.sakura.surface_scale != 100:
                x1 = x1 * self.sakura.surface_scale / 100
                x2 = x2 * self.sakura.surface_scale / 100
                y1 = y1 * self.sakura.surface_scale / 100
                y2 = y2 * self.sakura.surface_scale / 100
            self.surface_pixmap.draw_rectangle(surface_gc, 0, x1, y1, x2 - x1, y2 - y1)
    def show_surface(self):
        self.darea.window.set_back_pixmap(self.surface_pixmap, gtk.FALSE)
        self.window.shape_combine_mask(self.mask_pixmap, 0, 0)
        w, h = self.get_surface_size(self.surface_id)
        self.darea.queue_draw_area(0, 0, w, h)
    def reset_overlays(self):
        self.overlays = {}
    def remove_overlay(self, actor):
        try:
            del self.overlays[actor]
        except KeyError:
            pass
    def add_overlay(self, actor, id, x, y):
        if id == "-2":
            self.terminate()
        if id in ["-1", "-2"]:
            self.remove_overlay(actor)
            return
        self.overlays[actor] = (id, x, y)
    def draw_overlays(self):
        ##print "draw_overlays()"
        pixbuf = self.get_pixbuf(self.surface_id)
        w = pixbuf.get_width()
        h = pixbuf.get_height()
        if self.surface_cache.has_key(self.surface_id):
            surface_pixbuf =  self.surface_cache[self.surface_id].copy()
        else:
            surface_pixbuf = pixbuf.copy()
            if self.mayuna.has_key(self.surface_id):
                done = []
                for actor in self.mayuna[self.surface_id]:
                    id = actor.get_id()
                    if self.bind.has_key(id) and self.bind[id][1] and \
                       id not in done:
                        done.append(id)
                        sueface_pixbuf = self.compose_surface(surface_pixbuf, actor, done)
                self.surface_cache[self.surface_id] = surface_pixbuf.copy()
        actors = self.overlays.keys()
        actors.sort(lambda a1, a2: cmp(a1.get_id(), a2.get_id()))
        for actor in actors:
            id, x, y = self.overlays[actor]
            ##print "actor=%d, id=%s, x=%d, y=%d" % (actor.get_id(), id, x, y)
            try:
                pixbuf = self.get_pixbuf(id)
                w = pixbuf.get_width()
                h = pixbuf.get_height()
            except KeyError:
                continue
            # overlay surface pixbuf
            sw = surface_pixbuf.get_width()
            sh = surface_pixbuf.get_height()
            if x + w > sw:
                w = sw - x
            if y + h > sh:
                h = sh - y
            if x < 0:
                dest_x = 0
                w = w + x
            else:
                dest_x = x
            if y < 0:
                dest_y = 0
                h = h + y
            else:
                dest_y = y
            pixbuf.composite(surface_pixbuf, dest_x, dest_y, w, h, x, y, 1.0, 1.0, gtk.gdk.INTERP_BILINEAR, 255)
        if self.sakura.surface_scale != 100:
            w = surface_pixbuf.get_width() * self.sakura.surface_scale / 100
            h = surface_pixbuf.get_height() * self.sakura.surface_scale / 100
            surface_pixbuf = surface_pixbuf.scale_simple(w, h, gtk.gdk.INTERP_BILINEAR)
        self.surface_pixmap, self.mask_pixmap = surface_pixbuf.render_pixmap_and_mask(255)
        if self.debug & 4096:
            self.draw_region()
        self.show_surface()
    def move_surface(self, xoffset, yoffset):
        x, y = self.get_position()
        p, q = self.window_offset
        self.window.move(x + p + xoffset, y + q + yoffset)
    def get_balloon_offset(self):
        path, config = self.surface['surface' + self.surface_id]
        if self.side == 0:
            x = config.get("sakura.balloon.offsetx", None)
            y = config.get("sakura.balloon.offsety", None)
        else:
            x = config.get("kero.balloon.offsetx", None)
            y = config.get("kero.balloon.offsety", None)
        try:
            x = int(x)
        except:
            x = None
        try:
            y = int(y)
        except:
            y = None
        return x, y
    def get_surface(self):
        return self.surface_id
    def get_surface_size(self, id=None):
        if id == None:
            pixbuf = self.get_pixbuf(self.surface_id)
        else:
            pixbuf = self.get_pixbuf(id)
        w = pixbuf.get_width()
        h = pixbuf.get_height()
        if self.sakura.surface_scale != 100:
            w = int(w * self.sakura.surface_scale / 100)
            h = int(h * self.sakura.surface_scale / 100)
        return w, h
    def get_surface_offset(self):
        if getattr(self, 'window_offset', None):
            return self.window_offset
        else:
            return (0, 0)
    def get_touched_region(self, x, y):
        for part, x1, y1, x2, y2 in self.collisions:
            if x1 <= x <= x2 and y1 <= y <= y2:
                ##print part, "touched"
                return part
        return ""
    def set_direction(self, dir):
        self.direction = dir # 0: left, 1: right
    def set_position(self, x, y):
        if getattr(self, 'window_offset', None):
            p, q = self.window_offset
        else:
            p, q = (0, 0)
        self.window.parse_geometry("+%d+%d" % (x + p, y + q))
        self.position = (x, y)
    def get_position(self):
        return self.position
    def set_alignment(self, align):
        if align in [0, 1, 2]:
            self.align = align
    def get_alignment(self):
        return self.align
    def destroy(self):
        self.surface_cache = {}
        for tag in self.callbacks:
            self.darea.disconnect(tag)
        self.window.remove(self.darea)
        self.darea.destroy()
    def show(self):
        if not self.shown:
            self.window.show()
            self.show_surface()
            self.raise_()
            self.shown = 1
    def hide(self):
        if self.shown:
            self.window.hide()
            self.shown = 0
    def raise_(self):
        self.window.window.raise_()
    def lower(self):
        self.window.window.lower()
    def button_press(self, window, event):
        self.sakura.reset_idle_time()
        x = int(event.x)
        y = int(event.y)
        if self.sakura.surface_scale != 100:
            x = int(x * 100 / self.sakura.surface_scale)
            y = int(y * 100 / self.sakura.surface_scale)
        self.x_root = event.x_root
        self.y_root = event.y_root
        if event.type == gtk.gdk.BUTTON_PRESS:
            click = 1
        else:
            click = 2
        self.sakura.notify_surface_click(event.button, click, self.side, x, y)
        return gtk.TRUE
    def button_release(self, window, event):
        if self.dragged:
            self.sakura.notify_surface_drop()
            self.dragged = 0
        self.x_root = None
        self.y_root = None
        return gtk.TRUE
    def motion_notify(self, darea, event):
        if not self.sakura.busy():
            if event.state & gtk.gdk.BUTTON2_MASK:
                if self.x_root is not None and \
                   self.y_root is not None:
                    x_delta = int(event.x_root - self.x_root)
                    y_delta = int(event.y_root - self.y_root)
                    self.dragged = 1
                    self.raise_()
                    self.sakura.notify_surface_drag(self.side, x_delta, y_delta)
                    self.x_root = event.x_root
                    self.y_root = event.y_root
            elif event.state & gtk.gdk.BUTTON1_MASK or \
                 event.state & gtk.gdk.BUTTON3_MASK:
                pass
            else:
                x = int(event.x)
                y = int(event.y)
                if self.sakura.surface_scale != 100:
                    x = int(x * 100 / self.sakura.surface_scale)
                    y = int(y * 100 / self.sakura.surface_scale)
                part = self.get_touched_region(x, y)
                if part:
                    cursor = gtk.gdk.Cursor(gtk.gdk.HAND1)
                    self.darea.window.set_cursor(cursor)
                else:
                    self.darea.window.set_cursor(None)
                self.sakura.notify_surface_mouse_motion(self.side, x, y)
        return gtk.TRUE
    def scroll(self, darea, event):
        x = int(event.x)
        y = int(event.y)
        if self.sakura.surface_scale != 100:
            x = int(x * 100 / self.sakura.surface_scale)
            y = int(y * 100 / self.sakura.surface_scale)
        if event.direction == gtk.gdk.SCROLL_UP:
            direction = 'up'
        elif event.direction == gtk.gdk.SCROLL_DOWN:
            direction = 'down'
        else:
            direction = ''
        self.sakura.notify_surface_mouse_scroll(self.side, x, y, direction)
        return gtk.TRUE
    def get_pointer(self):
        self.darea.window.get_pointer()
    def toggle_bind(self, id):
        if self.bind.has_key(id):
            current = self.bind[id][1]
            self.bind[id][1] = not current
            self.surface_cache = {}
            self.reset_surface()

def test():
    pass

if __name__ == "__main__":
    test()
